/*
	PIP - Platform Independent Primitives
	PICloud Client
	Ivan Pelipenko peri4ko@yandex.ru, Andrey Bychkov work.a.b@yandex.ru

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "picloudclient.h"
#include "picloudtcp.h"


PICloudClient::PICloudClient(const PIString & path, PIIODevice::DeviceMode mode) : PIIODevice(path, mode), PICloudBase() {
	tcp.setRole(PICloud::TCP::Client);
	setName("cloud_client");
	is_connected = false;
	CONNECTL(&eth, connected, [this](){tcp.sendStart();});
	CONNECTU(&streampacker, packetReceiveEvent, this, _readed);
	CONNECTL(&eth, disconnected, [this](bool){
		piCoutObj << "disconnected";
		opened_ = false;
		is_connected = false;
		cond_connect.notifyOne();
		cond_buff.notifyOne();
		piMSleep(100);
	});
}


PICloudClient::~PICloudClient() {
	eth.close();
	if (is_connected) {
		is_connected = false;
		cond_buff.notifyOne();
		cond_connect.notifyOne();
	}
	close();
	stop();
}


void PICloudClient::setServerName(const PIString & server_name) {
	setName("cloud_client__" + server_name);
	tcp.setServerName(server_name);
}


void PICloudClient::setKeepConnection(bool on) {
	eth.setParameter(PIEthernet::KeepConnection, on);
}


bool PICloudClient::openDevice() {
//	piCout << "PICloudClient open device" << path();
	bool op = eth.connect(PIEthernet::Address::resolve(path()), false);
	if (op) {
		mutex_buff.lock();
		eth.startThreadedRead();
		bool conn_ok = cond_connect.waitFor(mutex_buff, (int)eth.readTimeout(), [this](){return isConnected();});
		piCoutObj << "conn_ok" << conn_ok;
		mutex_buff.unlock();
		if (!conn_ok) {
			eth.stop();
			eth.close();
			piMSleep(100);
		}
		return isConnected();
	} else {
		eth.close();
		return false;
	}
}


bool PICloudClient::closeDevice() {
	if (is_connected) {
		is_connected = false;
		cond_buff.notifyOne();
		cond_connect.notifyOne();
	}
	eth.stop();
	if (eth.isOpened()) eth.close();
	return true;
}


int PICloudClient::readDevice(void * read_to, int max_size) {
//	piCoutObj << "readDevice";
	if (!is_connected) return -1;
	mutex_buff.lock();
	cond_buff.wait(mutex_buff, [this](){return !buff.isEmpty();});
	int sz = piMini(max_size, buff.size());
	memcpy(read_to, buff.data(), sz);
	buff.remove(0, sz);
	mutex_buff.unlock();
	return sz;
}


int PICloudClient::writeDevice(const void * data, int size) {
//	piCoutObj << "writeDevice";
	return tcp.sendData(PIByteArray(data, size));
}


void PICloudClient::_readed(PIByteArray & ba) {
	mutex_buff.lock();
	PIPair<PICloud::TCP::Type, PICloud::TCP::Role> hdr = tcp.parseHeader(ba);
	if (hdr.second == tcp.role()) {
		switch (hdr.first) {
		case PICloud::TCP::Connect:
			if (tcp.parseConnect(ba) == 1) {
				is_connected = true;
				cond_connect.notifyOne();
			}
		break;
		case PICloud::TCP::Disconnect:
			is_connected = false;
			eth.stop();
			eth.close();
		break;
		case PICloud::TCP::Data:
			if (is_connected) {
				buff.append(ba);
				cond_buff.notifyOne();
			}
		break;
		default:
		break;
		}
		//piCoutObj << "readed" << ba.toHex();
	}
	mutex_buff.unlock();
	while (buff.size_s() > threadedReadBufferSize()) piMSleep(100);
}

